#ifdef IGNORE_ME
  #define ident "@(#) c_exception.h (/sccs/ri_util/include/s.c_exception.h) 1.2 02/24/99 14:20:44";
#endif

  /*  c_exception.h
  Copyright 1997 Kyle R. Burton

This file is part of c_exception.h, an attempt at a win32 equivalent for
the system log daemon available under unix.

c_exception.h is free software; you can redistribute it and/or modify
it under the tearms of the GNU General Public License as published by 
the Free Software Foundation; either version 2, or (at your option)
any later version.

c_exception.h is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with c_exception.h; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

*/
#if !defined( _C_EXCEPTION_H )
#define _C_EXCEPTION_H

#include <string.h>
#include "stdinc.h"

class c_exception 
{
public:
  c_exception() {
    m_msg = (char*)NULL;
    m_file = (char*)NULL;
    m_num = 0;
    m_line = -1;
  };

  c_exception( const char* msg, char* file, int line ) {
    m_msg = new char[strlen(msg)+1];
    strcpy( m_msg, msg );
    m_file = file;
    m_line = line;
    m_num = 0;
  };

  c_exception( const c_exception& that ) {
    (*this) = that;
  };
public:
  virtual ~c_exception() {
    delete m_msg;
  };

  static c_exception* New( const char* msg = (char*)NULL, char* file = (char*)NULL, int line = 0 ) {
    return( new c_exception( msg, file, line ) );
  };

  virtual const c_exception& operator=( const c_exception& right ) {
    delete m_msg;
    m_msg = new char[strlen(right.m_msg)+1];
    strcpy( m_msg, right.m_msg );
    m_num = right.m_num;
    m_file = right.m_file;
    m_line = right.m_line;
    return( *this );
  };


public:
  char*  m_msg, *m_file;
  int    m_num, m_line;

private:
  void init( void ) {
    m_msg = (char*)NULL;
  };
};

extern c_exception g_exception;

#if 0
#define eTHROW(a)  { \
            g_exception.m_line = __LINE__; \
            g_exception.m_file = __FILE__; \
            g_exception.m_num = a; \
          }
#endif

#endif // !defined( _C_EXCEPTION_H )

