#ifdef IGNORE_ME
#define ident "@(#) c_key_val_pair.h (/sccs/ri_util/include/s.c_key_val_pair.h) 1.4 02/24/99 14:20:45";
#endif

/*
 * file: c_key_val_pair.h
 *
 * description:  implements a simple 'key,value' object.  Both, key and value
 * 	are c_strings.
 *
 */

#if !defined( _C_KEY_VAL_PAIR_H )
#define _C_KEY_VAL_PAIR_H
#include "c_string.h"
#include <c_exception.h>
#include "c_list.h"

class c_key_val_pair
{
public:

	c_key_val_pair()
	: _key()
	, _value()
	{
		; // do nothing
	};

	void set_data(const char * k, const char * v)
	{
		_key = k;
		_value = v;
	};
	void set_data(const char * k, c_string& v)
	{
		_key = k;
		_value = v;
	};
	void set_data(c_string& k, c_string& v)
	{
		_key = k;
		_value = v;
	};

	void get_data(c_string& k, c_string& v) const
	{
		k = _key;
		v = _value;
	};

	int operator==( const c_key_val_pair& right ) const
	{
		throw( c_exception("Compare function is not implemented", __FILE__, __LINE__ ) );
		return(0);
	};

	void clear_fields()
	{
		_key = c_string();
		_value = c_string();
	};
private:

	c_string _value;
	c_string _key;

};
#endif  // !defined( _C_KEY_VAL_PAIR_H )
