#ifdef IGNORE_ME
#define ident "@(#) c_tree_mapper.h (/sccs/ri_util/include/s.c_tree_mapper.h) 1.8 02/24/99 14:20:45";
#endif
/*
 * file: c_tree_mapper.h
 *
 * description:  given input key, value pairs and a template tree, it will
 * 	create an unordered tree based on template
 *
 */

#if !defined ( _C_TREE_MAPPER )
#define _C_TREE_MAPPER

#include <c_collection.h>
#include <c_list.h>
#include <c_key_val_pair.h>

#define UNINITIALIZED_VALUE "_PYCTO_"

class c_tree_mapper
{
public:

	c_tree_mapper( void )
	: dummy_tree()
	, tmpl_t_hand(dummy_tree)
	, unrd_t_hand(dummy_tree)
	, list_idx(-1)
	{
		new_tree_hash.remove_all();
	};

	virtual ~c_tree_mapper()
	{
// go through new_tree_hash and delete all handles
		c_map_pair<c_string, c_multi_tree_manipulator<c_string,c_string>*> pair;
		c_collection_iter<c_map_pair<c_string, c_multi_tree_manipulator<c_string,c_string>*> > * iter;
		iter = new_tree_hash.prepare_iter();
		while (new_tree_hash.next(iter, pair))
		{
			delete pair.m_value;
		}
		new_tree_hash.complete_iter(iter);
	};

	int build_tree(c_list<c_key_val_pair>& input_recs, const c_multi_tree_manipulator<c_string,c_string>& tmpl_t_hand, const c_multi_tree_manipulator<c_string, c_string>& unord_t_hand);

	int build_tree(c_list<c_key_val_pair>& input_recs, const c_hash<c_string, c_string>& templ_tree_fields_hash, const c_multi_tree_manipulator<c_string,c_string>& tmpl_t_hand);

	int get_handle(const c_string node_name, c_multi_tree_manipulator<c_string,c_string>& handle);

	void get_tree(c_multi_tree<c_string,c_string>& tree);

	void populate_join_keys(const c_multi_tree_manipulator<c_string, c_string>& _handle);

	void create_frame_new_tree(const c_multi_tree_manipulator<c_string,c_string>& tmpl_t_hand);

	static void set_tree_keys_from_values(const c_multi_tree_manipulator<c_string, c_string>& _handle);

	static int print_tree(const c_multi_tree_manipulator<c_string, c_string>& _handle);

	static int adopt_children(const c_multi_tree_manipulator<c_string,c_string>& destination_h, const c_multi_tree_manipulator<c_string,c_string>& source_h);

private:
	int process_a_node(c_list<c_key_val_pair>& input_recs);

	int find_node_in_tree(c_string v_to_find, const c_multi_tree_manipulator<c_string, c_string>& _handle, c_multi_tree_manipulator<c_string, c_string>& find_handle);

	int value_set(const c_string& _value);

	c_multi_tree<c_string,c_string> dummy_tree;
	c_multi_tree_manipulator<c_string,c_string> tmpl_t_hand;
	c_multi_tree_manipulator<c_string,c_string> unrd_t_hand;
	int list_idx;
// hash table containing node names and handle pointers to the tree we build
	c_hash<c_string, c_multi_tree_manipulator<c_string,c_string>*> new_tree_hash;
};

#endif // !defined( _C_TREE_MAPPER )
