#ifdef IGNORE_ME
  #define ident "@(#) stdinc.h (/sccs/ri_util/include/s.stdinc.h) 1.3 02/24/99 14:20:44";
#endif

  /*  stdinc.h
  Copyright 1997 Kyle R. Burton

stdinc.h is free software; you can redistribute it and/or modify
it under the tearms of the GNU General Public License as published by 
the Free Software Foundation; either version 2, or (at your option)
any later version.

stdinc.h is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with stdinc.h see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/*

=head1 NAME

stdinc.h - standard include header

=head1 SYNOPSIS

	#include <stdinc.h>

=head1 DESCRIPTION

Priovides stanard define macros for things like TRUE (1),
FALSE (0), NULL ((void*)0), BOOL (int), etc...

=head1 BUGS

No known bugs.

=head1 AUTHORS

Kyle R. Burton mortis@voicenet.com

=head1 SEE ALSO

=cut

*/


#if !defined( _STDINC_H )
#define _STDINC_H 1
#include <c_timestamp.h>


  /* if TRUE, FALSE, BOOL, and NULL aren't already defined, define them */

#if !defined( TRUE ) 
#  define TRUE 1
#endif /* !defined( TRUE ) */

#if !defined( FALSE )
#  define FALSE 0
#endif /* !defined( FALSE ) */

#if !defined( EXIT_SUCCESS )
#define EXIT_SUCCESS 0
#endif /* !defined( EXIT_SUCCESS ) */

#if !defined( EXIT_FAILURE )
#define EXIT_FAILURE 1
#endif /* !defined( EXIT_SUCCESS ) */

#if !defined( USER_EXIT )
#define USER_EXIT  2
#endif /* !defined( USER_EXIT ) */

#if 0
#if !defined( BOOL )
#  define BOOL int
#endif /* !defined( BOOL ) */
#endif

#if !defined( NULL )
#  define NULL    ( (void*)(0) )
#endif /* !defined( NULL ) */


#if !defined( _MAX_PATH )
  /*
   * the maximum path/filename length - plus the '\0'
   */
#  define _MAX_PATH  255
#endif /* !defined( _MAX_PATH ) */

  /* type casting macros */
#define CHAR(a)      ( (char*)(a) )
#define INT(a)      ( (int*)(a) )
#define FLOAT(a)    ( (float*)(a) )
#define DOUBLE(a)    ( (double*)(a) )

  /* standard exceptions, for c_exception */
#define EXCEPTION_NO_EXCEPTION      0x00000000
#define EXCEPTION_UNKNOWN_EXCEPTION             0xFFFFFFFF
#define EXCEPTION_MEM_ALLOC_FAILURE             0x00000001
#define EXCEPTION_FILE_OPEN_ERROR               0x00000002
#define EXCEPTION_OBJECT_DESTRUCTOR_FAILURE     0x00000004
#define EXCEPTION_FEATURE_UNIMPLEMENTED         0x00000008
#define EXCEPTION_FILE_CLOSE_ERROR              0x00000010
#define EXCEPTION_FILE_READ_ERROR               0x00000011
#define EXCEPTION_UNKNOWN_CMD_LINE_SWITCH       0x00000012
#define EXCEPTION_MISSING_INI_SETTING           0x00000014
#define EXCEPTION_ASSERTION_FAILED              0x00000018
#define EXCEPTION_METHOD_NOT_IMPLEMENTED  0x00000020
#define EXCEPTION_INVALID_ARRAY_INDEX    0x00000040
#define EXCEPTION_MEMORY_LEAK      0x00000080

  /* user defined exceptions.. */
#define EXCEPTION_CSV_STRUCT_MISMATCH    0x10000000
#define EXCEPTION_CSV_FIND_REC_ERROR    0x10000001
#define EXCEPTION_BAD_FUNCION_ARG    0x10000002

  /* text for standard exceptions */
#define SZ_EXCEPTION_UNKNOWN_EXCEPTION             "EXCEPTION_UNKNOWN_EXCEPTION"
#define SZ_EXCEPTION_MEM_ALLOC_FAILURE             "EXCEPTION_MEM_ALLOC_FAILURE"
#define SZ_EXCEPTION_FILE_OPEN_ERROR               "EXCEPTION_FILE_OPEN_ERROR"
#define SZ_EXCEPTION_OBJECT_DESTRUCTOR_FAILURE     "EXCEPTION_OBJECT_DESTRUCTOR_FAILURE"
#define SZ_EXCEPTION_FEATURE_UNIMPLEMENTED         "EXCEPTION_FEATURE_UNIMPLEMENTED"
#define SZ_EXCEPTION_FILE_CLOSE_ERROR              "EXCEPTION_FILE_CLOSE_ERROR"
#define SZ_EXCEPTION_FILE_READ_ERROR               "EXCEPTION_FILE_READ_ERROR"
#define SZ_EXCEPTION_UNKNOWN_CMD_LINE_SWITCH       "EXCEPTION_UNKNOWN_CMD_LINE_SWITCH"
#define SZ_EXCEPTION_MISSING_INI_SETTING           "EXCEPTION_MISSING_INI_SETTING"
#define SZ_EXCEPTION_ASSERTION_FAILED              "EXCEPTION_ASSERTION_FAILED"
#define SZ_EXCEPTION_INVALID_ARRAY_INDEX           "EXCEPTION_INVALID_ARRAY_INDEX"
#define SZ_EXCEPTION_MEMORY_LEAK                   "EXCEPTION_MEMORY_LEAK"

  /* text for user defined exceptions */
#define SZ_EXCEPTION_CSV_STRUCT_MISMATCH           "EXCEPTION_CSV_STRUCT_MISMATCH"
#define SZ_EXCEPTION_CSV_FIND_REC_ERROR             "EXCEPTION_CSV_FIND_REC_ERROR"

  /* debug and assert macros */
#if defined( _DEBUG )
#  define _DEBUG_MSG  printf
#  if !defined( _ASSERT )

#     define _ASSERT(a,b,c)  if( !(a) ) { \
        sprintf( g_exception.m_msg, \
          "ASSERTION Failed in file: %s at line: %d", \
          (b), (c) ); \
        }
#  endif
#  define _DEBUG_COND(a)  (a)
#else // defined( _DEBUG )
void _null_function( char*, ... );
#  define _DEBUG_MSG    _null_function
#  if !defined( _ASSERT )
#     define _ASSERT(a,b,c)
#  endif
#  define _DEBUG_COND(a)
#endif // defined( _DEBUG )

// this is a diagnostic used to display warnings whenever a class has more than this number of
// instances
#define INSTANCE_COUNT_WARNING  100

// #define _DEBUG2  1

#define COUT_FILE  __FILE__ << "(" << __LINE__ << ") "

#define ERROR(o)  o << NOW << COUT_FILE << "ERROR  : "
#define WARN(o)   o << NOW << COUT_FILE << "WARNING: "
#define INFO(o)   o << NOW << COUT_FILE << "INFO   : "

#endif // !defined( _STDINC_H )

